#include <math.h>
#include <iostream>
#include <fstream>
using namespace std;

const int ROWS = 10;
const int COLS = 10;
const int MAXL = 50;
const int NERO = 0;
const int BIANCO = 100;

struct Immagine {
	int data[ROWS][COLS];
	char titolo[MAXL];
};


bool leggi(Immagine* m, char nf[]) {
	fstream ff;
	ff.open(nf, ios::in);
	if(!ff)	return false;
	ff >> m->titolo;
	for(int i=0; i<ROWS; i++)
		for(int j=0; j<COLS; j++)
			ff >> m->data[i][j];
	return ff;
}

int medio(Immagine* m, int r, int c) {
	int cont = 0;
	int startr = r == 0 ? r : r - 1;
	int endr = r == ROWS - 1 ? ROWS - 1 : r + 1;
	int startc = c == 0 ? c : c - 1;
	int endc = c == COLS - 1 ? COLS - 1 : c + 1;
	for(int i=startr; i<=endr; i++)
		for(int j=startc; j<=endc; j++) 
			cont += m->data[i][j];
	cont -= m->data[r][c];
	int num = (endc - startc + 1) * (endr -startr + 1) - 1;
	int risul = (int) round((float) cont / num);
	m->data[r][c] = risul;
	return risul;
}

void luminoso(const Immagine* m, int* pr, int* pc) {
	int maxlum = 0;
	*pr = 0; 
	*pc = 0;
	for(int i=0; i<ROWS; i++) 
		for(int j=0; j<COLS; j++)
			if(m->data[i][j] > maxlum) {
				*pr = i;
				*pc = j;
				maxlum = m->data[i][j];
			}
}


void trasforma(Immagine* m, int soglia) {
	for(int i=0; i<ROWS; i++)
		for(int j=0; j<COLS; j++)
			if(m->data[i][j] <= soglia) m->data[i][j] = NERO;
			else m->data[i][j] = BIANCO;
}

void stampa(const Immagine* m) {
	cout << m->titolo << endl;
	for(int i=0; i<ROWS; i++) {
		for(int j=0; j<COLS; j++)
			switch(m->data[i][j]){
				case NERO:
					cout << ' ';
					break;
				case BIANCO:
					cout << 'X';
					break;
				default:
					cout << '-';
			}
		cout << endl;
	}
}

